page    66,132
title   esempio modi di indirizzamento etc.
;
comment *
-------------------------------------------------------------------------------------------------
File sorgente:  addm.asm
        (prima scrittura: novembre 1997)

Scopo:      mostrare le diverse modalita' di indirizzamento
        e l'impiego dei registri, attraverso la manipolazione
                e la scrittura di un messaggio.
                Il messaggio SOURCE viene trasferito in DEST
                ogni volta riducendolo di un carattere; DEST viene
            quindi stampato. In un caso SOURCE viene
            trasferito nello stack e stampato dallo stack.
-------------------------------------------------------------------------------------------------
*
;
    ; macro per la stampa su video di una stringa, usando l'int 21h del DOS
display macro   text        ; text deve terminare con "$"
    mov     dx,offset text  ; ds:dx -> stringa da stampare
    mov     ah,9
    int     21h
    endm
;
    ; segmento di stack
stack   segment stack 'stack'
    db  40 dup('stack')
t_o_s   label   word
stack   ends
;
    ; segmento dati
data    segment public 'data'
cr  equ     13
lf  equ     10
mark    equ     $
            db      cr,lf,"addm 1.01 - maggio 2001",cr,lf,lf
            db  '$'
source  db  "quarantaquattro gatti in fila per sei"
    db  " col resto di due"
    db  cr,lf,"$"
strlen  equ $ - source
dest    db  strlen dup(?)
finis   label   byte
    db  cr,lf,'fine del ritornello',cr,lf,'$'
data    ends
;
    ; segmento di codice
cseg    segment public 'code'
addm    proc far
    assume cs:cseg,ds:data,ss:stack,es:data
    push    ds  ; si salva ds:0000
    sub     ax,ax   ; per tornare al DOS
    push    ax  ; con l'istruzione ret
;
    mov     ax,data
    mov     ds,ax
    mov     es,ax   ; le operazioni sulle stringhe usano es
;
        mov     ax,stack; superflue: lo stack lo aggiusta il DOS
        mov     ss,ax
;
    display mark    ; messaggio d'esordio
;
    ; Uso di un solo registro (in funzione di base) e displacement
    ; Al posto di BX poteva esserci DI o SI, oppure BP usando DS:displ[BP]
    sub     bx,bx
lab0:   mov     al,source[bx]   ; indirizzamento register relative:
    mov     dest[bx],al ; DS:[BX+displ], dove displ e' pari al
    inc     bx              ; location counter del segmento
    cmp     al,'$'
    jne     lab0
    display dest
;
        ; Trasferimento tramite i registri base BX e BP usati come puntatori
        ; diretti al carattere da trasferire. Notare il "segment prefix" per
        ; BP (che lavora usualmente con SS). Potevano essere usati SI e DI
        ; al posto di qualunque dei precedenti
        MOV     BX,OFFSET SOURCE
        MOV     BP,OFFSET DEST
lab1:   mov     al,[bx][1]  ; equivale a mov al,[bx+1]: si trasferisce
    mov     ds:[bp],al      ; la stringa a partire dal secondo carattere
    inc     bx
    inc     bp
    cmp     al,'$'
    jne     lab1
    display dest
;
        ; Traferimento con uso dei registri SI e DI e displacement
            xor     di,di       ; modo alternativo per svuotare un registro
            xor     si,si
lab2:       mov     al,source[si+2]
    mov     dest[di],al
    inc     si
    inc     di
    cmp     al,'$'
    jne     lab2
    display dest
;
        ; Trasferimento con uso di registro base, indice e displacement
        ; (relative base indexed)
            mov     bx,offset source; equivale a lea bx,source
            sub     di,di
lab3:   mov     al,[bx][di][3]  ; equivale a mov al,[bx+di+3]
    mov     (dest-source)[bx+di],al
    inc     di
    cmp     al,'$'
    jne     lab3
    display dest
;
        ; Trasferimento da source a dest con piu' registri
        lea     bx,dest
        xor si,si
        mov     bp,offset source
lab4:   mov     al,ds:[bp+4+si]
    mov [bx+si],al
    inc si
    cmp     al,'$'
    jne     lab4
    display dest
;
    ; Trasferimento nello stack e stampa dallo stack
    mov     si,strlen   ; lunghezza stringa source
    mov bx,offset source
    mov     cx,sp       ; salvato sp
lab5:   mov     ah,[bx+si-1]    ; si preleva dalla fine
    dec si
    cmp si,5        ; tutta la stringa meno 5 caratteri
    je  odd5        ; numero di caratteri dispari
    mov     al,[bx+si-1]    ; si preleva dalla fine
    dec si
    cmp si,5        ; tutta la stringa meno 5 caratteri
    je  even5       ; numero di caratteri pari
    push    ax      ; carattere messo nello stack
    jmp lab5
;
odd5:   push    ax
    mov     dx,sp       ; si tiene conto di un numero
    inc dx      ; dispari di caratteri
    jmp disp5
even5:  push    ax
    mov     dx,sp       ; numero pari di caratteri
disp5   label   near
    push    ds      ; il DOS vuole l'indirizzo stringa in ds:dx
    mov     ax,ss
    mov ds,ax
    mov ah,9
    int 21h
;
        pop ds
        mov sp,cx       ; stack come all'entrata per ret al DOS
;
    ; Uso delle istruzioni di stringa
    mov si,offset source + 6
    mov di,offset dest
    mov cx,strlen - 6
    cld         ; DF (direction flag) e' messa a 0: cosi'
lab6:   movsb           ; nel loop c'e' autoincremento dei registri
    loop    lab6        ; (DF = 1 -> autodecremento)
    display dest
;
    ;
    mov     si,offset source + 7
    mov di,offset dest
    cld
    mov     cx,strlen-7
    rep movsb       ; equivale a:    label  movsb
    display dest        ;           loop label
;
            ;
    display finis
    ret         ; return far al DOS (pop di CS:IP = PPS:0000)
                ; con PSP = Program Segment Prefix
        addm    endp
        ;
        cseg    ends
        end addm
